<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use Mail;
use Exception;

class ProcurementLevelAutoEscalationCron extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'app:procurement-level-auto-escalation-cron';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Auto Escalation of Procurement Level after time limit exceed';

    /**
     * Execute the console command.
     */
    public function handle(): void
    {
        \Log::info("is log working");
        $todaysDate = date('Ymd');
        // $loginUser = $aToken['data']->ID;  
        $currentTimestamp = strtotime("now");
        $dbSeedVerification = config('custom.mysql_seed_verification');
        $databaseName = config('custom.seed_ver_db_name');

        $sSQL = 'SELECT `id`,`state_id`,`district_id`,`program_id`,`brand_id`,`local_vendor_comp_id`,`current_level`,`is_submit_date`,`current_team_id`,`send_notification` FROM `cc_procurment` WHERE is_submit = 1 AND tracebell_status = 0';
        $procurementData = DB::connection($dbSeedVerification)->select($sSQL, array());
        // dd($procurementData);
        foreach($procurementData as $procData){ 
            $procurementId  = $procData->id;
            $stateId        = $procData->state_id;
            $districtId     = $procData->district_id;
            $programId     = $procData->program_id;
            $brandId        = $procData->brand_id;
            $localVendorCompanyId = $procData->local_vendor_comp_id;
            $procCurrentLevel = $procData->current_level;
            $procSendNotification = $procData->send_notification;
            //dump($procurementId);
            $sSQL = 'SELECT `level` levels,`team`,`is_last_level`,`auto_submit`,timeframe,(SELECT `team` FROM `cc_escalation_level` WHERE `level` = levels+1 AND `district_id`=:innerDistrict AND `program_id`=:innerProgram AND `brand_id`=:innerBrand AND `local_vendor_comp_id`=:innerCompany) next_team FROM `cc_escalation_level` WHERE `district_id`=:districtId AND `program_id`=:programId AND `brand_id`=:brandId AND `local_vendor_comp_id`=:localVendorCompanyId';
            $escalationData = DB::connection($dbSeedVerification)->select($sSQL, array(
                'innerDistrict' => $districtId,
                'innerProgram' => $programId,
                'innerBrand' => $brandId,
                'innerCompany' => $localVendorCompanyId,
                'districtId' => $districtId,
                'programId' => $programId,
                'brandId' => $brandId,
                'localVendorCompanyId' => $localVendorCompanyId
            ));
            //dd($escalationData);
            $team_array = array();
            foreach($escalationData as $escData){
                if($escData->auto_submit == 1){
                    //auto escalate code
                    $team_array[] = $escData->team; 
                    $nextTeam = is_null($escData->next_team) ? $escData->team : $escData->next_team;
                    $nextLevel = $escData->is_last_level == 1 ? $escData->levels : $escData->levels + 1;
                    
                    $sSQL = 'INSERT INTO cc_procurment_farmer_status (procurment_id, procuremnent_farmer_id, current_level, current_team, is_appr_rejected, approved_quantity, approved_rate, approved_total_amount, approved_by, approved_date,is_auto_escalated) SELECT procurment_request_id, id, current_level, current_team_id, :isApprove, approve_quantity, approved_rate, approved_total_amount, :approvedBy, :approvedDate,1 FROM cc_procurment_farmers
                    WHERE `procurment_request_id`=:procurmentRequestId AND `current_level`=:currentLevel AND current_status != 2 AND UNIX_TIMESTAMP(NOW()) - `auto_esc_timestamp` > :autoEscTime';
                    $isInserted = DB::connection($dbSeedVerification)->insert($sSQL,array(
                        'approvedDate' => strtotime("now"),
                        'approvedBy' => $escData->team,
                        'isApprove' => 1,
                        'procurmentRequestId' => $procurementId,
                        'currentLevel' => $escData->levels,
                        'autoEscTime' => ($escData->timeframe*60)
                    ));

                    $sSQL = 'SELECT `id` FROM `cc_procurment_farmer_status` WHERE `procurment_id`=:procurmentRequestId AND `is_auto_escalated`=1';
                    $getInsertData = DB::connection($dbSeedVerification)->select($sSQL, [
                        'procurmentRequestId' => $procurementId
                    ]);
                    
                    if(count($getInsertData) > 0){
                        $sSQL = 'UPDATE `cc_procurment_farmers` SET `current_status`=:currentStatus,`current_level`=:nextLevel,`current_team_id`=:nextTeamId,`auto_esc_timestamp`=:currentTimestamp,`is_overdue`=:isOverdue WHERE `procurment_request_id` =:procurmentRequestId AND current_level =:currentLevel AND current_status != 2';
                        DB::connection($dbSeedVerification)->update($sSQL,array(
                            'currentStatus' => 1,
                            'nextLevel' => $nextLevel,
                            'nextTeamId' => $nextTeam,
                            'currentTimestamp' => $currentTimestamp,
                            'isOverdue' => 0,
                            'procurmentRequestId' => $procurementId,
                            'currentLevel' => $escData->levels,
                        ));

			        if($procCurrentLevel < $nextLevel){
                        	$sSQL = 'UPDATE `cc_procurment` SET `current_level`=:nextLevel,`current_team_id`=:nextTeamId WHERE `id`=:procurmentRequestId';
                        	DB::connection($dbSeedVerification)->update($sSQL,array(
                            	'nextLevel' => $nextLevel,
                            	'nextTeamId' => $nextTeam,
                            	'procurmentRequestId' => $procurementId
                        	));
                        }

                        $sSQL = 'UPDATE `cc_procurment_farmer_status` SET is_auto_escalated=0 WHERE `procurment_id`=:procurmentRequestId';
                        DB::connection($dbSeedVerification)->update($sSQL,array(
                            'procurmentRequestId' => $procurementId
                        ));
                    }
                    \Log::info("Auto escalated Success!");
                    
                }else{
                    if($escData->timeframe > 0){
                        $sSQL = 'UPDATE `cc_procurment_farmers` SET `is_overdue`=:isOverdue,`auto_esc_timestamp`=:currentTimestamp WHERE `procurment_request_id` =:procurmentRequestId AND current_level =:currentLevel AND current_status != 2 AND UNIX_TIMESTAMP(NOW()) - `auto_esc_timestamp` > :autoEscTime';
                        DB::connection($dbSeedVerification)->update($sSQL,array(
                            'isOverdue' => 1,
                            'procurmentRequestId' => $procurementId,
                            'currentTimestamp' => $currentTimestamp,
                            'currentLevel' => $escData->levels,
                            'autoEscTime' => ($escData->timeframe*60)
                        ));
                        \Log::info("Is overdue Success!");
                    }
                    
                } 
            }
      
            //----------- send email
            if($procCurrentLevel > $procSendNotification)
            {
                $mailFrom = config('custom.mail_from');
                $mailName = config('custom.mail_name');

                $sSQL = 'SELECT count(id) as total_record, sum(purchase_quantity) as total_quantity FROM `cc_procurment_farmers` WHERE `procurment_request_id` = '.$procurementId.' AND `current_level` = '.$procCurrentLevel.' AND `current_team_id` = '.$procData->current_team_id.' ';
            
                $procurementData1 = DB::connection($dbSeedVerification)->select($sSQL, array());
                $data['total_record']   = !empty($procurementData1) ? $procurementData1[0]->total_record : 0;
                $data['total_quantity'] = !empty($procurementData1) ? $procurementData1[0]->total_quantity : 0;
                //dd($procurementData1);
                $data['submit_date'] = !empty($procData->is_submit_date) ? date('Y-m-d',strtotime($procData->is_submit_date)) : '-';

                $sSQL1 = 'SELECT count(id) as village_count,(select name from master_village where id = cc_procurment_farmers.village_id) as village_name FROM `cc_procurment_farmers` WHERE `procurment_request_id` = '.$procurementId.' AND `current_level` = '.$procCurrentLevel.' AND `current_team_id` = '.$procData->current_team_id.' ' ;
                $sSQL1 .= ' GROUP BY village_id';
                $villageResult = DB::connection($dbSeedVerification)->select($sSQL1, array());
                $village_array = array_column($villageResult,'village_name');
                $data['village_name'] = implode(", ",$village_array);

                $sSQL = 'SELECT p.`id`,IFNULL((SELECT concat(firstname," ",lastname) FROM `users` WHERE `id`=p.ginner_id),"") ginner_name,IFNULL((SELECT `program_name` FROM master_programes WHERE id=p.program_id),"") as program_name,IFNULL((SELECT `brand_name` FROM master_brands WHERE id=p.brand_id),"") as brand_name,IFNULL((SELECT `name` FROM master_districts WHERE id=p.district_id),"") as district_name FROM '.$databaseName.'.cc_procurment p WHERE p.id = '.$procurementId.' AND p.is_submit=1 ';
                $sheetResult = DB::select($sSQL, array());
                
                $program_name = !empty($sheetResult[0]->program_name) ? str_replace("\r\n","",$sheetResult[0]->program_name) : '';
                $data['sheet_name'] = $sheetResult[0]->ginner_name.'_'.$sheetResult[0]->district_name.'_'.$program_name.'_'.$sheetResult[0]->brand_name;
                $data['flag'] = 2;
                
                $team_ids = implode(',',$team_array);
                //dd($team_ids);
                $sUSERLIST = 'SELECT `username` FROM `users` WHERE user_role IN('.$team_ids.') AND username != "" ';
                $auserMails = DB::select($sUSERLIST, array());  // final email send ids
                if(!empty($auserMails)){
                    $userEmailArray = array_column($auserMails,'username');  
                }else{
                    $userEmailArray = [];
                }
                //dd($userEmailArray);

                $usermailIds1 = ['vishalbhagwat@standardwings.com','prathameshjagtap@standardwings.com'];
                //dd($data);
                $subjectLine = $sheetResult[0]->ginner_name.' submitted procurement sheet'; 

                try{
                    Mail::send('send_mail_procurement_user', $data, function($message) use ($usermailIds1,$subjectLine,$mailFrom,$mailName) {
                        $message->to($usermailIds1)->subject($subjectLine);
                        $message->from($mailFrom,$mailName);
                    });
                // return true;
                }
                catch(Exception $e){
                    //exit;
                // return false;
                }
            }
            //------------------- end -----------------------
            
        }
    }



    // public function handle(): void
    // {
    //     \Log::info("is log working");
    //     $todaysDate = date('Ymd');
    //     // $loginUser = $aToken['data']->ID;  
    //     $currentTimestamp = strtotime("now");
    //     $dbSeedVerification = config('custom.mysql_seed_verification');
    //     $databaseName = config('custom.seed_ver_db_name');

    //     $sSQL = 'SELECT `id`,`state_id`,`district_id`,`program_id`,`brand_id`,`local_vendor_comp_id` FROM `cc_procurment` WHERE is_submit = 1 AND tracebell_status = 0';
    //     $procurementData = DB::connection($dbSeedVerification)->select($sSQL, array());

    //     foreach($procurementData as $procData){
    //         $procurementId  = $procData->id;
    //         $stateId        = $procData->state_id;
    //         $districtId     = $procData->district_id;
    //         $programId     = $procData->program_id;
    //         $brandId        = $procData->brand_id;
    //         $localVendorCompanyId = $procData->local_vendor_comp_id;
    //         //dump($procurementId);
    //         $sSQL = 'SELECT `level` levels,`team`,`is_last_level`,`auto_submit`,timeframe,(SELECT `team` FROM `cc_escalation_level` WHERE `level` = levels+1 AND `district_id`=:innerDistrict AND `program_id`=:innerProgram AND `brand_id`=:innerBrand AND `local_vendor_comp_id`=:innerCompany) next_team FROM `cc_escalation_level` WHERE `district_id`=:districtId AND `program_id`=:programId AND `brand_id`=:brandId AND `local_vendor_comp_id`=:localVendorCompanyId';
    //         $escalationData = DB::connection($dbSeedVerification)->select($sSQL, array(
    //             'innerDistrict' => $districtId,
    //             'innerProgram' => $programId,
    //             'innerBrand' => $brandId,
    //             'innerCompany' => $localVendorCompanyId,
    //             'districtId' => $districtId,
    //             'programId' => $programId,
    //             'brandId' => $brandId,
    //             'localVendorCompanyId' => $localVendorCompanyId
    //         ));
    //         // dd($escalationData);
    //         foreach($escalationData as $escData){
    //             if($escData->auto_submit == 1){
    //                 //auto escalate code
    //                 $nextTeam = is_null($escData->next_team) ? $escData->team : $escData->next_team;
    //                 $nextLevel = $escData->is_last_level == 1 ? $escData->levels : $escData->levels + 1;
    //                 $sSQL = 'INSERT INTO cc_procurment_farmer_status (procurment_id, procuremnent_farmer_id, current_level, current_team, is_appr_rejected, approved_quantity, approved_rate, approved_total_amount, approved_by, approved_date) SELECT procurment_request_id, id, current_level, current_team_id, :isApprove, approve_quantity, approved_rate, approved_total_amount, :approvedBy, :approvedDate FROM cc_procurment_farmers
    //                 WHERE `procurment_request_id`=:procurmentRequestId AND `current_level`=:currentLevel AND current_status != 2 AND TIMESTAMPDIFF(MINUTE, FROM_UNIXTIME(`auto_esc_timestamp`), NOW()) > :autoEscTime';
    //                 $isInserted = DB::connection($dbSeedVerification)->insert($sSQL,array(
    //                     'approvedDate' => $todaysDate,
    //                     'approvedBy' => $escData->team,
    //                     'isApprove' => 1,
    //                     'procurmentRequestId' => $procurementId,
    //                     'currentLevel' => $escData->levels,
    //                     'autoEscTime' => $escData->timeframe
    //                 ));
                    
    //                 if($isInserted){
    //                     $sSQL = 'UPDATE `cc_procurment_farmers` SET `current_status`=:currentStatus,`current_level`=:nextLevel,`current_team_id`=:nextTeamId,`auto_esc_timestamp`=:currentTimestamp,`is_overdue`=:isOverdue WHERE `procurment_request_id` =:procurmentRequestId AND current_level =:currentLevel AND current_status != 2';
    //                     DB::connection($dbSeedVerification)->update($sSQL,array(
    //                         'currentStatus' => 1,
    //                         'nextLevel' => $nextLevel,
    //                         'nextTeamId' => $nextTeam,
    //                         'currentTimestamp' => $currentTimestamp,
    //                         'isOverdue' => 0,
    //                         'procurmentRequestId' => $procurementId,
    //                         'currentLevel' => $escData->levels,
    //                     ));

    //                     $sSQL = 'UPDATE `cc_procurment` SET `current_level`=:nextLevel,`current_team_id`=:nextTeamId WHERE `id`=:procurmentRequestId';
    //                     DB::connection($dbSeedVerification)->update($sSQL,array(
    //                         'nextLevel' => $nextLevel,
    //                         'nextTeamId' => $nextTeam,
    //                         'procurmentRequestId' => $procurementId
    //                     ));
    //                 }
    //                 \Log::info("Auto escalated Success!");
    //             }else{
    //                 $sSQL = 'UPDATE `cc_procurment_farmers` SET `is_overdue`=:isOverdue,`auto_esc_timestamp`=:currentTimestamp, WHERE `procurment_request_id` =:procurmentRequestId AND current_level =:currentLevel AND current_status != 2 AND TIMESTAMPDIFF(MINUTE, FROM_UNIXTIME(`auto_esc_timestamp`), NOW()) > :autoEscTime';
    //                 DB::connection($dbSeedVerification)->update($sSQL,array(
    //                     'isOverdue' => 1,
    //                     'procurmentRequestId' => $procurementId,
    //                     'currentTimestamp' => $currentTimestamp,
    //                     'currentLevel' => $escData->levels,
    //                     'autoEscTime' => $escData->timeframe
    //                 ));
    //                 \Log::info("Is overdue Success!");
    //             }
    //         }
    //     }
    // }
}